NNMainForm = {}

NNMainForm.tPixies = {}

NNMainForm.tPixies.tHarvest = {
	strText = "",
	strFont = "CRB_Interface9",
	strSprite = "NN_Harvest_100",
	bLine = false,
	crText = "ffffffff",
	cr = "ffff0000",
	loc = { fPoints = { 0, 0, 1, 1 }, nOffsets = { 0, 0, 0, 0 } },
	flagsText = { DT_BOTTOM = false, DT_RIGHT = false, DT_CENTER = false, DT_VCENTER = false }
}

NNMainForm.tPixies.tNeighborCount = {
	strText = "",
	strFont = "CRB_Interface9",
	strSprite = "",	
	bLine = false,
	crText = "ffffff00",
	loc = {	fPoints = { 0, 0, 1, 1 },	nOffsets = { 0, 0, -12, 0 } },
	flagsText = { DT_BOTTOM = false, DT_RIGHT = true, DT_CENTER = false, DT_VCENTER = true }
}

NNMainForm.tPixies.tNodeTier = {
	strText = "",
	strFont = "CRB_Pixel_O",
	strSprite = "",	
	bLine = false,
	crText = "ffffff00",
	loc = {	fPoints = { 0, 0, 1, 1 }, nOffsets = { 0, 0, 0, 0 }	},
	flagsText = { DT_BOTTOM = true, DT_RIGHT = true, DT_CENTER = false, DT_VCENTER = false }
}

NNMainForm.tPixies.tVisitBtn = {
	strText = "",
	strFont = "",
	strSprite = "",	
	bLine = false,
	crText = "ffffff00",
	loc = { fPoints = { 0, 0, 1, 1 }, nOffsets = { 10, 10, -10, -10 } },
	flagsText = { DT_BOTTOM = false, DT_RIGHT = false, DT_CENTER = true, DT_VCENTER = true }
}

NNMainForm.tPixies.tPlugIcon = {
	strText = "",
	strFont = "",
	strSprite = "",	
	bLine = false,
	crText = "ffffff00",
	loc = { fPoints = { 0, 0, 0, 1 }, nOffsets = { 0, 0, 30, 0 } },
	flagsText = { DT_BOTTOM = false, DT_RIGHT = false, DT_CENTER = true, DT_VCENTER = true }
}

NNMainForm.tPixies.tPlugName = {
	strText = "",
	strFont = "",
	strSprite = "",	
	bLine = false,
	crText = "ffffff00",
	loc = { fPoints = { 0, 0, 1, 1 }, nOffsets = { 30, 0, 0, 0 } },
	flagsText = { DT_BOTTOM = false, DT_RIGHT = false, DT_CENTER = false, DT_VCENTER = true }
}

------------------------------------------------------------------------------------------
-- Main Draw
------------------------------------------------------------------------------------------
function NNMainForm:Load()
	self.xmlDoc = XmlDoc.CreateFromFile("MainForm.xml")
	if not self.xmlDoc then
		Apollo.AddAddonErrorText("Could not load MainForm")
	end
end

function NNMainForm:Init()
	if not self.wndMain or not self.wndMain:IsValid() then
		self.wndMain = Apollo.LoadForm(self.xmlDoc, "NeighborListForm", nil, self)
		if not self.wndMain then
			Apollo.AddAddonErrorText(self, "Could not load the NeighborNotes window.")
			return
		end
		Apollo.LoadSprites("NNSprites.xml")
		Event_FireGenericEvent("WindowManagementAdd", {wnd = self.wndMain, strName = "Neighbor Notes"})

		self.wndModify = self.wndMain:FindChild("ModifyWindow")		
		self.wndListContainer = self.wndMain:FindChild("ListContainer")
		self.wndMain:FindChild("AddMemberCloseBtn"):SetData(self.wndMain:FindChild("AddWindow"))
		self.wndMain:FindChild("EditNoteCloseBtn"):SetData(self.wndMain:FindChild("EditNoteWindow"))
		self.wndMain:FindChild("NodeFilterCloseBtn"):SetData(self.wndMain:FindChild("NodeFilterWindow"))
		self.wndMain:FindChild("NeighborFilterCloseBtn"):SetData(self.wndMain:FindChild("NeighborFilterWindow"))
		self.wndMain:FindChild("CheckboxShowNeighbors"):SetCheck(true)
		self.wndMain:FindChild("TradeSkillCheckbox"):SetCheck(NeighborNotes.tCharacter.tFilters.bHarvestable)
		self.wndMain:FindChild("NotesRadioBtn"):SetCheck(NeighborNotes.tCharacter.tFilters.bShowNotes)
		NNMainForm.wndMain:FindChild("TheVisitorBtn"):Show(NeighborNotes.bVisitor)
		NNMainForm.wndMain:FindChild("HousingTourBtn"):Show(NeighborNotes.bHousingTour)
		-- Set the default sort
		self.wndMain:FindChild("Label_Friend"):SetCheck(true)
		self:OnNeighborSortToggle(self.wndMain:FindChild("Label_Friend"))

		-- add plug list
		local wndPlugContainer = self.wndMain:FindChild("PlugContainer")
		local wndPlugItem = Apollo.LoadForm(self.xmlDoc, "PlugListItem", wndPlugContainer, self)
		local wndButton = wndPlugItem:FindChild("PlugButton")
		self.tPixies.tPlugName.strText = "Show All Plugs"
		wndButton:AddPixie(self.tPixies.tPlugName)
		wndButton:SetData(0)
		wndButton:SetCheck(true)
		self.wndSelected = wndButton
		local tTempTable = {}
		for nPlugID, tPlug in pairs(NeighborNotes.tEnums.tPlugs) do
			if nPlugID < 50 or nPlugID > 80 then
				if nPlugID ~= 1 then
					table.insert(tTempTable, { ["nPlugID"] = nPlugID, ["strIcon"] = tPlug.strIcon } )
				end
			end
		end
		table.sort(tTempTable, function(a,b) return a.nPlugID < b.nPlugID end )
		for nIndex, tPlug in pairs(tTempTable) do
			wndPlugItem = Apollo.LoadForm(self.xmlDoc, "PlugListItem", wndPlugContainer, self)
			wndButton = wndPlugItem:FindChild("PlugButton")
			if tPlug.strIcon == nil then
				if tPlug.nPlugID < 101 then
					self.tPixies.tPlugIcon.strSprite = "IconSprites:Icon_CraftingUI_Item_Crafting_PowerCore_Blue"
				elseif tPlug.nPlugID < 201 then
					self.tPixies.tPlugIcon.strSprite = NeighborNotes.tEnums.tPlugType["Biome"].strIcon
				elseif tPlug.nPlugID < 401 then
					self.tPixies.tPlugIcon.strSprite = NeighborNotes.tEnums.tPlugType["Challenge"].strIcon
				elseif tPlug.nPlugID < 601 then
					self.tPixies.tPlugIcon.strSprite = NeighborNotes.tEnums.tPlugType["Expedition"].strIcon
				elseif tPlug.nPlugID < 801 then
					self.tPixies.tPlugIcon.strSprite = NeighborNotes.tEnums.tPlugType["Raid"].strIcon
				elseif tPlug.nPlugID < 1001 then
					self.tPixies.tPlugIcon.strSprite = NeighborNotes.tEnums.tPlugType["PublicEvent"].strIcon
				end
			else
				self.tPixies.tPlugIcon.strSprite = tPlug.strIcon
			end
			self.tPixies.tPlugName.strText = NeighborNotes.tLiveData.tPlugs[tPlug.nPlugID]
			wndButton:AddPixie(self.tPixies.tPlugIcon)
			wndButton:AddPixie(self.tPixies.tPlugName)
			wndButton:SetData(tPlug.nPlugID)
		end
		wndPlugContainer:ArrangeChildrenVert()
	end
end

-- Shows the Neighbor Notes Window (or hides it if it is already open)
function NNMainForm:Open(bShow)
	if not self.wndMain and bShow ~= false then
		self:Init()
		NeighborNotes:RefreshList()			
	elseif self.wndMain:IsShown() and bShow ~= true then
		self.wndMain:Close()
		return
	end
	self.wndMain:Invoke()	
	self.wndMain:ToFront()
end

function NNMainForm:Close()
	if self.wndMain and self.wndMain:IsShown() then
		self.wndMain:Close()
	end
end

function NNMainForm:Refresh()
	if not self.wndMain or not self.wndMain:IsShown() then
		return
	end
	
	self.tPixies.tNeighborCount["strText"] = tostring(#NeighborNotes.tDisplayedList)
	self.wndListContainer:DestroyChildren()
	self.wndSelectedListItem = nil

	self.wndMain:FindChild("Label_Friend"):UpdatePixie(1, self.tPixies.tNeighborCount)
	
	-- Populate the List Container
	for key, tCurrNeighbor in pairs(NeighborNotes.tDisplayedList) do
		local wndListItem = Apollo.LoadForm(self.xmlDoc, "NeighborListItem", self.wndListContainer, self)
		wndListItem:SetData(tCurrNeighbor) -- set the full table since we have no direct lookup for neighbors
		local strColorToUse = NeighborNotes.tColors.crOffline
		if tCurrNeighbor.fLastOnline == 0 then -- online / check for strWorldZone
			strColorToUse = NeighborNotes.tColors.crOnline
		end
		local wndName = wndListItem:FindChild("Name")
		local wndNote = wndListItem:FindChild("Notes")
		local wndNode = wndListItem:FindChild("Node")
		wndName:SetText(tCurrNeighbor.strCharacterName)
		wndName:SetTextColor(strColorToUse)
		wndName:SetTooltip(NeighborNotes:GetNameTooltip(tCurrNeighbor))
		if NeighborNotes.tCharacter.tFilters.bShowNotes then
			if not string.IsEmpty(tCurrNeighbor.strNote) then
				wndNote:SetText(tCurrNeighbor.strNote)
				wndNote:SetTextColor(strColorToUse)
			end
		else
			wndNote:SetText(NeighborNotes:HelperConvertToTime(tCurrNeighbor.fLastOnline))
			wndNote:SetTextColor(strColorToUse)
		end
		local wndIcon = wndListItem:FindChild("RoommateIcon")
		if tCurrNeighbor.ePermissionNeighbor == HousingLib.NeighborPermissionLevel.Roommate then
			wndIcon:Show(true)
			wndIcon:SetSprite("ClientSprites:Icon_Windows_UI_CRB_Attribute_Health")
			wndIcon:SetTooltip(Apollo.GetString("Neighbors_RoommateTooltip"))
		elseif tCurrNeighbor.ePermissionNeighbor == 999 then
			wndIcon:Show(true)
			wndIcon:SetSprite("DatachronSprites:btnBagFullNormal")
			wndIcon:SetTooltip("This is a neighbor of another character")
		elseif tCurrNeighbor.ePermissionNeighbor == 998 then
			wndIcon:Show(true)
			wndIcon:SetSprite("CRB_GuildSprites:sprGuild_BlueMap_Stretchable")
			wndIcon:SetTooltip("This is not a neighbor, but they have Neighbor Notes")
		else
			wndIcon:Show(false)
		end
		
		wndIcon = wndListItem:FindChild("AccountIcon")
			wndIcon:Show(tCurrNeighbor.ePermissionNeighbor == HousingLib.NeighborPermissionLevel.Account)
		if tCurrNeighbor.ePermissionNeighbor == HousingLib.NeighborPermissionLevel.Account then
			wndIcon:SetTooltip(Apollo.GetString("Neighbors_RoommateTooltip"))
		end
		
		-- Add Icons for Guild and Circle Members
		wndIcon = wndListItem:FindChild("GroupIcon")
		local strGroupTooltip = ""
		if not string.IsEmpty(tCurrNeighbor.strGroups) then
			wndIcon:Show(true)
			wndIcon:SetText("G")
			strGroupTooltip = tCurrNeighbor.strGroups
		else
			wndIcon:SetText("")		
			wndIcon:Show(false)
		end
		if tCurrNeighbor.bHasNN then
			wndIcon:Show(true)
			wndIcon:SetSprite("CRB_GuildSprites:sprGuild_BlueMap_Stretchable")
		end
		if strGroupTooltip and strGroupTooltip ~= "" then
			wndIcon:SetTooltip(strGroupTooltip)
		end
		wndName:SetTextColor(strColorToUse)
		
		if tCurrNeighbor.nNodeID ~= nil and tCurrNeighbor.nNodeID ~= 0 then
			--wndNode:SetSprite(NeighborNotes.tEnums.tNodes[tCurrNeighbor.nNodeID].strIcon)
			if tCurrNeighbor.nNodeID > 50 and tCurrNeighbor.nNodeID < 61 then
				wndNode:SetSprite(NeighborNotes.tIcons.strRelic)
			elseif tCurrNeighbor.nNodeID > 60 and tCurrNeighbor.nNodeID < 71 then
				wndNode:SetSprite(NeighborNotes.tIcons.strTree)
			elseif  tCurrNeighbor.nNodeID > 70 and tCurrNeighbor.nNodeID < 81 then
				wndNode:SetSprite(NeighborNotes.tIcons.strMining)
			end
			local nNodeTier = tCurrNeighbor.nNodeID % 10
			local strNodeTier = nil
			if nNodeTier > 4 then
				strNodeTier = "E"
			else
				strNodeTier = tostring(nNodeTier)
			end
			self.tPixies.tNodeTier.strText = strNodeTier
			wndNode:AddPixie(self.tPixies.tNodeTier)
			local strNodeTooltip = NeighborNotes.tLiveData.tPlugs[tCurrNeighbor.nNodeID]
			if tCurrNeighbor.eShare then
				if tCurrNeighbor.eShare == 4 then
					self.tPixies.tHarvest.strSprite = "NNSprites:NN_Harvest_100"
					strNodeTooltip = strNodeTooltip .. "\n Get 100% of harvested goods"
				elseif tCurrNeighbor.eShare == 3 then
					self.tPixies.tHarvest.strSprite = "NNSprites:NN_Harvest_75"
					strNodeTooltip = strNodeTooltip .. "\n Get 75% of harvested goods"
				elseif tCurrNeighbor.eShare == 2 then
					self.tPixies.tHarvest.strSprite = "NNSprites:NN_Harvest_50"
					strNodeTooltip = strNodeTooltip .. "\n Get 50% of harvested goods"
				elseif tCurrNeighbor.eShare == 1 then
					self.tPixies.tHarvest.strSprite = "NNSprites:NN_Harvest_25"
					strNodeTooltip = strNodeTooltip .. "\n Get 25% of harvested goods"
				else
					self.tPixies.tHarvest.strSprite = "NNSprites:NN_Harvest_0"
					strNodeTooltip = strNodeTooltip .. "\n Get 0% of harvested goods"
				end
				wndNode:AddPixie(self.tPixies.tHarvest)
			end
			if tCurrNeighbor.fNodeExpiration ~= nil then
				local nTimeLeft = (math.abs(tCurrNeighbor.fNodeExpiration) - os.time()) / 3600
				if nTimeLeft > 0 then
					strNodeTooltip = strNodeTooltip .. "\nExpires in " .. strRound(nTimeLeft, 2) .. " hours"
				else
					strNodeTooltip = strNodeTooltip .. "\nNeeds Repairs"
					self.tPixies.tHarvest.strSprite = "CRB_CharacterCreateSprites:sprCharC_ClassFooterIconDisabled"
					wndNode:AddPixie(self.tPixies.tHarvest)
				end
			end
			wndNode:SetTooltip(strNodeTooltip)
		end
		if tCurrNeighbor.tPlugs ~= nil then
			for nIndex, nPlugID in ipairs(tCurrNeighbor.tPlugs) do
				if nPlugID ~= nil and nPlugID ~= 0 then
					local wndPlug = wndListItem:FindChild("Plug" .. nIndex)
					if not wndPlug then -- There are currently 7 plug spots, any more than 7 will not be shown
						break
					end
					if NeighborNotes.tEnums.tPlugs[nPlugID].strIcon == nil then
						if nPlugID < 101 then
							wndPlug:SetSprite("IconSprites:Icon_CraftingUI_Item_Crafting_PowerCore_Blue")
						elseif nPlugID < 201 then
							wndPlug:SetSprite(NeighborNotes.tEnums.tPlugType["Biome"].strIcon)
						elseif nPlugID < 401 then
							wndPlug:SetSprite(NeighborNotes.tEnums.tPlugType["Challenge"].strIcon)
						elseif nPlugID < 601 then
							wndPlug:SetSprite(NeighborNotes.tEnums.tPlugType["Expedition"].strIcon)
						elseif nPlugID < 801 then
							wndPlug:SetSprite(NeighborNotes.tEnums.tPlugType["Raid"].strIcon)
						elseif nPlugID < 1001 then
							wndPlug:SetSprite(NeighborNotes.tEnums.tPlugType["PublicEvent"].strIcon)
						end
					else
						wndPlug:SetSprite(NeighborNotes.tEnums.tPlugs[nPlugID].strIcon)
					end
					wndPlug:SetTooltip(NeighborNotes.tLiveData.tPlugs[nPlugID])
					-- Update Pixies for Festival Plugs
					if nPlugID > 010 and nPlugID < 017 then
						if nPlugID == 011 then
							self.tPixies.tNodeTier["strText"] = "1"
						elseif nPlugID == 012 then
							self.tPixies.tNodeTier["strText"] = "2"
						elseif nPlugID == 013 then
							self.tPixies.tNodeTier["strText"] = "3"
						elseif nPlugID == 014 then
							self.tPixies.tNodeTier["strText"] = "4"
						elseif nPlugID == 015 then
							self.tPixies.tNodeTier["strText"] = "5"
						elseif nPlugID == 016 then
							self.tPixies.tNodeTier["strText"] = "6"
						end
						wndPlug:UpdatePixie(1, self.tPixies.tNodeTier)
					end
				end
			end
		end
	end
	self.wndListContainer:ArrangeChildrenVert()
	self:UpdateSelection()
	self:UpdateControls()
end

function NNMainForm:MsgBox(strMessage)
	if not self.wndMsgBox then
		self.wndMsgBox = Apollo.LoadForm(self.xmlDoc, "MessageWindow", nil, self)
		if not self.wndMsgBox then
			Apollo.AddAddonErrorText(self, "Could not load the MessageBox Window.")
			return
		end
		Event_FireGenericEvent("WindowManagementAdd", {wnd = self.wndMsgBox, strName = "Neighbor Notes Message Window"})
		NeighborNotes.wndMsgBox = self.wndMsgBox
	end
	
	local wndEditBox = self.wndMsgBox:FindChild("EditBox")
	if string.IsEmpty(strMessage) then
		return
	else
		strMessage = strMessage .. "\n" .. wndEditBox:GetText()
		wndEditBox:SetText(strMessage)
	end
	self.wndMsgBox:Show(true)
	self.wndMsgBox:ToFront()
end

function NNMainForm:OnMsgBoxClose(wndHandler, wndControl, mouseBtn)
	self.wndMsgBox:FindChild("EditBox"):SetText("")
	wndControl:GetParent():Show(false)
end

function NNMainForm:UpdateSelection()
	if not self.wndMain or not self.wndMain:IsValid() then
		return
	end
	if self.wndSelectedListItem then
		self.wndSelectedListItem:FindChild("FriendBtn"):SetCheck(false)
		self.wndSelectedListItem = nil
	end
	local nPos = 1
	if NeighborNotes.tLiveData.tSelectedNeighbor then
		for nNum, wndListItem in ipairs(self.wndListContainer:GetChildren()) do
			local tCurr = wndListItem:GetData()	
			if tCurr.strCharacterName == NeighborNotes.tLiveData.tSelectedNeighbor.strCharacterName then
				wndListItem:FindChild("FriendBtn"):SetCheck(true)
				self.wndSelectedListItem = wndListItem
				local nHeight = self.wndListContainer:GetHeight()
				nHeight = nHeight - nHeight%40
				nHeight = nHeight/40
				nHeight = nHeight - nHeight%2
				nHeight = nHeight/2
				self.wndListContainer:SetVScrollPos(nPos - nHeight*40)
				return
			end
			nPos = nPos + 40
		end
	end
end

-- This is called to update the controls at the bottom of the window, changing the appearance of the buttons
--	depending on the current location or selected user
function NNMainForm:UpdateControls()
	if not self.wndMain or not self.wndMain:IsValid() then
		return
	end

	local wndControls = self.wndMain:FindChild("Controls")
	local tCurr = NeighborNotes.tLiveData.tSelectedNeighbor
	
	local wndHomeBtn = wndControls:FindChild("TeleportHomeBtn")
	local wndEditNoteBtn = wndControls:FindChild("EditNoteBtn")
	local wndVisitBtn = wndControls:FindChild("VisitBtn")
	local wndAddBtn = wndControls:FindChild("AddBtn")
	local wndModifyBtn = wndControls:FindChild("ModifyBtn")
	local wndHTBtn = wndControls:FindChild("HousingTourBtn")
	local wndVisitorBtn = wndControls:FindChild("TheVisitorBtn")
	
	local wndMiscTab = self.wndMain:FindChild("Label_Notes")
	if NeighborNotes.tCharacter.tFilters.bShowNotes then
		wndMiscTab:SetText("Notes")
	else
		wndMiscTab:SetText("Last Online")
	end
	
	wndAddBtn:SetData(nil)
	
	-- must be on my skymap to visit; must be on someone else's to return (add button)
	if HousingLib.IsHousingWorld() == true then
		self.tPixies.tVisitBtn["strSprite"] = "ClientSprites:Icon_Mission_Explorer_ExplorerDoor"
		self.tPixies.tVisitBtn["strText"] = ""
		self.tPixies.tVisitBtn["cr"] = "ffffffff"
		self.tPixies.tVisitBtn["crText"] = "ffffffff"
		wndHomeBtn:UpdatePixie(1, self.tPixies.tVisitBtn)
		self.tPixies.tVisitBtn["strSprite"] = ""
		self.tPixies.tVisitBtn["strText"] = "V"
		self.tPixies.tVisitBtn["strFont"] = "CRB_HeaderGigantic_O"
		wndVisitorBtn:DestroyPixie(1)
		wndVisitorBtn:AddPixie(self.tPixies.tVisitBtn)
		self.tPixies.tVisitBtn["strText"] = "KHT"
		self.tPixies.tVisitBtn["strFont"] = "CRB_HeaderTiny_O"
		wndHTBtn:DestroyPixie(1)
		wndHTBtn:AddPixie(self.tPixies.tVisitBtn)
	else
		self.tPixies.tVisitBtn["strSprite"] = "ClientSprites:Icon_Mission_Explorer_ExplorerDoor"
		self.tPixies.tVisitBtn["strText"] = ""
		self.tPixies.tVisitBtn["cr"] = "25aaaaaa"
		self.tPixies.tVisitBtn["crText"] = "25aaaaaa"
		wndHomeBtn:UpdatePixie(1, self.tPixies.tVisitBtn)
		self.tPixies.tVisitBtn["strSprite"] = ""
		self.tPixies.tVisitBtn["strText"] = "V"
		self.tPixies.tVisitBtn["strFont"] = "CRB_HeaderGigantic_O"
		wndVisitorBtn:DestroyPixie(1)
		wndVisitorBtn:AddPixie(self.tPixies.tVisitBtn)
		self.tPixies.tVisitBtn["strText"] = "KHT"
		self.tPixies.tVisitBtn["strFont"] = "CRB_HeaderTiny_O"
		wndHTBtn:DestroyPixie(1)
		wndHTBtn:AddPixie(self.tPixies.tVisitBtn)
	end

	wndHomeBtn:Enable(HousingLib.IsHousingWorld())
	wndVisitBtn:Enable(HousingLib.IsHousingWorld())
	wndHTBtn:Enable(HousingLib.IsHousingWorld())
	wndVisitorBtn:Enable(HousingLib.IsHousingWorld())
	
	if not tCurr then
		wndVisitBtn:Enable(false)
		wndEditNoteBtn:Enable(false)
		wndModifyBtn:Enable(false)
		return
	end
	
	wndEditNoteBtn:SetData(tCurr)
	wndEditNoteBtn:Enable(true)
	wndModifyBtn:Enable(true)
	
	if not tCurr.nId then
		wndAddBtn:SetData(tCurr)
		wndModifyBtn:FindChild("ModifyRemoveBtn"):Enable(false)
		wndModifyBtn:FindChild("ModifyRemoveNNBtn"):Enable(true)		
		if self.aHousingTour then
			wndVisitBtn:Enable(true)
			wndVisitBtn:SetData(tCurr)			
		else
			wndVisitBtn:Enable(false)
		end
		return
	end

	wndModifyBtn:SetData(tCurr)
	wndModifyBtn:FindChild("ModifyRemoveBtn"):Enable(true)
	wndModifyBtn:FindChild("ModifyRemoveNNBtn"):Enable(false)
	
	wndVisitBtn:Enable(HousingLib.IsHousingWorld())
	wndVisitBtn:SetData(tCurr)
end

function NNMainForm:IsShown()
	if self.wndMain and self.wndMain:IsShown() then
		return true
	end
	return false
end

--------------------------------------------------------------------------------------------------------
-- Form Events
--------------------------------------------------------------------------------------------------------
-- this is called when the friend button is pressed
function NNMainForm:OnFriendBtn(wndHandler, wndControl, eMouseButton)
	local tCurrNeighbor = wndControl:GetParent():GetData()
	if tCurrNeighbor == nil then
		return false
	end
	if self.wndSelectedListItem then
		self.wndSelectedListItem:FindChild("FriendBtn"):SetCheck(false)
	end
	self.wndSelectedListItem = wndControl:GetParent()
	wndControl:SetCheck(true)
	NeighborNotes:SelectNeighbor(tCurrNeighbor.strCharacterName)
	self:UpdateControls()
end

-- this fires when a friend is unselected
function NNMainForm:OnFriendBtnUncheck(wndHandler, wndControl, eMouseButton)
	if self.wndSelectedListItem then
		self.wndSelectedListItem:SetCheck(false)
	end
	NeighborNotes:SelectNeighbor()
	self:UpdateControls()
end

function NNMainForm:OnContextMenuOnlyBtn(wndHandler, wndControl)
	local tCurrNeighbor = wndControl:GetParent():GetData()
	Event_FireGenericEvent("GenericEvent_NewContextMenuPlayer", self.wndMain, tCurrNeighbor.strCharacterName)
end

-- When one of the table headers is clicked, this sets up the sort and calls RefreshList()
function NNMainForm:OnNeighborSortToggle( wndHandler, wndControl, eMouseButton )
	local bChecked = wndHandler:IsChecked()
	local strLastChecked = wndHandler:GetName()
	if strLastChecked == "Label_Friend" then
		NeighborNotes:SetSort(NeighborNotes.tEnums.tSortType["Name"], bChecked)
	elseif strLastChecked == "Label_Roommate" then
		NeighborNotes:SetSort(NeighborNotes.tEnums.tSortType["Permissions"], bChecked)
	elseif strLastChecked == "Label_Node" then
		NeighborNotes:SetSort(NeighborNotes.tEnums.tSortType["Node"], bChecked)
	elseif strLastChecked == "Label_Plugs" then
		NeighborNotes:SetSort(NeighborNotes.tEnums.tSortType["Plug"], bChecked)
	elseif strLastChecked == "Label_Notes" and wndHandler:GetText() == "Notes" then
		NeighborNotes:SetSort(NeighborNotes.tEnums.tSortType["Note"], bChecked)
	elseif strLastChecked == "Label_Notes" and wndHandler:GetText() == "Last Online" then
		NeighborNotes:SetSort(NeighborNotes.tEnums.tSortType["LastOnline"], bChecked)
	end
end

-- When a tab is right clicked, show the associated context window
function NNMainForm:OnTabClick( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY )
	if eMouseButton == GameLib.CodeEnumInputMouse.Right then
		local wndFilterWindow = wndControl:FindChild("FilterWindow")
		if wndFilterWindow then
			wndFilterWindow:SetFocus()
			wndFilterWindow:Show(true)
			wndFilterWindow:ToFront()
			return
		end
	end
end

function NNMainForm:OnMiscRadioBtn( wndHandler, wndControl, eMouseButton )
	if wndControl == self.wndMain:FindChild("NotesRadioBtn") then
		NeighborNotes.tCharacter.tFilters.bShowNotes = true
	elseif wndControl == self.wndMain:FindChild("LastOnlineRadioBtn") then
		NeighborNotes.tCharacter.tFilters.bShowNotes = false
	end
	NeighborNotes:RefreshList()	
	self.wndMain:FindChild("Label_Notes"):FindChild("FilterWindow"):Show(false)
end

-- AddNeighbor Sub-Window Functions
function NNMainForm:OnAddBtn(wndHandler, wndControl)
	local wndAdd = wndControl:FindChild("AddWindow")
	if wndAdd:IsVisible() then
		wndAdd:Show(false)
	else
		local wndEditBox = wndAdd:FindChild("AddMemberEditBox")
		local tCurr = NeighborNotes.tLiveData.tSelectedNeighbor
		wndEditBox:SetText("")
		if tCurr and not tCurr.nId then
			wndEditBox:SetText(tCurr.strCharacterName or "")
		end
		wndAdd:FindChild("AddMemberEditBox"):SetFocus()
		wndAdd:Show(true)
	end
end

function NNMainForm:OnAddMemberYesClick( wndHandler, wndControl )
	local wndParent = wndControl:GetParent()
	local strName = wndParent:FindChild("AddMemberEditBox"):GetText()
	if strName ~= nil and strName ~= "" then
		HousingLib.NeighborInviteByName(strName)
	end
	wndControl:GetParent():Show(false)
end

function NNMainForm:OnPlugFilterChange( wndHandler, wndControl )
	
end


-- Housing Tour Button Functions
function NNMainForm:OnHousingTourBtn( wndHandler, wndControl, eMouseButton )
	local wndHT = wndControl:FindChild("HTWindow")
	if wndHT:IsVisible() then
		wndHT:Show(false)
	else
		local tCurr = self.wndMain:FindChild("VisitBtn"):GetData()
		local wndEditBox = wndHT:FindChild("HTEditBox")
		if tCurr and tCurr.strCharacterName then
			wndEditBox:SetText(tCurr.strCharacterName)
		else
			wndEditBox:SetText("")
		end
		wndEditBox:SetFocus()
		wndHT:Show(true)
	end
end

function NNMainForm:OnHTGoClick( wndHandler, wndControl, strText )
	local wndParent = wndControl:GetParent()
	local strName = wndParent:FindChild("HTEditBox"):GetText()
	if strName ~= nil and strName ~= "" then
		Apollo.ParseInput("/ht " .. strName)
	else
		Apollo.ParseInput("/ht")
	end
	wndControl:GetParent():Show(false)
end

-- Visit Button Function
function NNMainForm:OnVisitBtn(wndHandler, wndControl, eMouseButton)
	NeighborNotes:VisitSelected()
end

-- Home Button Function
function NNMainForm:OnTeleportHomeBtn(wndHandler, wndControl)
	HousingLib.RequestTakeMeHome()
end

function NNMainForm:OnCloseBtn( wndHandler, wndControl, eMouseButton )
	self:Close()
end

function NNMainForm:OnEditNoteBtn( wndHandler, wndControl, eMouseButton )
	local wndEdit = wndControl:FindChild("EditNoteWindow")
	if wndEdit:IsVisible() then
		wndEdit:Show(false)
	else
		local wndEditBox = wndEdit:FindChild("NoteEditBox")
		local tCurr = NeighborNotes.tLiveData.tSelectedNeighbor
		if tCurr == nil then
			return
		end
		if tCurr.strCharacterName == nil or tCurr.strCharacterName == "" then
			return
		end
		local strNote = NeighborNotes:GetCharacterNote(tCurr.strCharacterName)
		wndEditBox:SetText(strNote)
		wndEditBox:SetFocus()
		wndEdit:Show(true)
	end
end

function NNMainForm:OnMinimizeBtn( wndHandler, wndControl, eMouseButton )
	NNSmallForm:Open()
	self:Close()
end

function NNMainForm:OnSubCloseBtn(wndHandler, wndControl, mouseBtn)
	wndControl:GetParent():Show(false)
end


function NNMainForm:OnNoteSubmitClick( wndHandler, wndControl)
	local wndParent = wndControl:GetParent()
	local strNote = wndParent:FindChild("NoteEditBox"):GetText()
	local tCurr = NeighborNotes.tLiveData.tSelectedNeighbor
	NeighborNotes:SetCharacterNote(tCurr.strCharacterName, strNote)
	wndParent:Show(false)
end

function NNMainForm:OnTradeSkillCheckBox( wndHandler, wndControl, eMouseButton )
	NeighborNotes.tCharacter.tFilters.bHarvestable = wndControl:IsChecked()
	wndControl:GetParent():Show(false)
	NeighborNotes:RefreshList()
end

function NNMainForm:OnAccountWideCheckBox( wndHandler, wndControl, eMouseButton )
	local strWindowName = wndControl:GetName()
	NeighborNotes.tLiveData.tFilters.bShowNeighbors = false
	NeighborNotes.tLiveData.tFilters.bShowNonNeighbors = false
	NeighborNotes.tLiveData.tFilters.bShowSearch = false
	NeighborNotes.tLiveData.tFilters.bShowCircles = false
	self.wndMain:FindChild("SearchBtn"):SetCheck(false)
	if strWindowName == "CheckboxShowAll" then
		NeighborNotes.tLiveData.tFilters.bShowNeighbors = true
		NeighborNotes.tLiveData.tFilters.bShowSearch = true
		NeighborNotes.tLiveData.tFilters.bShowNonNeighbors = true
	elseif strWindowName == "CheckboxShowNeighbors" then
		NeighborNotes.tLiveData.tFilters.bShowNeighbors = true
	elseif strWindowName == "CheckboxShowNonNeighbors" then
		NeighborNotes.tLiveData.tFilters.bShowNonNeighbors = true
	elseif strWindowName == "CheckboxShowSearch" then
		NeighborNotes.tLiveData.tFilters.bShowSearch = true
		self.wndMain:FindChild("SearchBtn"):SetCheck(true)
	else -- Show Guild/Circle
		NeighborNotes.tLiveData.tFilters.bShowNeighbors = true
		NeighborNotes.tLiveData.tFilters.bShowCircles = true
	end
	wndControl:GetParent():Show(false)
	NeighborNotes:RefreshList()
end

-- Opens the Node Filter Window
function NNMainForm:OnNodeTabClick( wndHandler, wndControl, eMouseButton)
	local wndNodeFilter = wndControl:FindChild("NodeFilterWindow")
	if wndNodeFilter ~= nil then
		if eMouseButton == GameLib.CodeEnumInputMouse.Right then
			wndNodeFilter:SetFocus()
			wndNodeFilter:Show(true)
		end
	end
end


function NNMainForm:OnSubWindowClosed( wndHandler, wndControl )
	wndControl:GetParent():SetCheck(false)
end

function NNMainForm:OnConfigBtn( wndHandler, wndControl, eMouseButton )
	NNConfigForm:Open()
end

function NNMainForm:OnVisitRandomBtn( wndHandler, wndControl, eMouseButton )
	Event_FireGenericEvent("HousingRandomResidenceListReceived", self.wndMain, nil)
end

function NNMainForm:OnTheVisitorBtn( wndHandler, wndControl, eMouseButton )
	Apollo.ParseInput("/visit")	
end

-- Modify Sub-Window Functions
function NNMainForm:OnModifyBtn(wndHandler, wndControl)
	local tCurr = NeighborNotes.tLiveData.tSelectedNeighbor
	if tCurr == nil then
		return
	end

	if self.wndModify:IsVisible() then
		self.wndModify:Show(false)
	else
		self.wndModify:SetData(tCurr)
		-- set the permissions button
		self.wndModify:FindChild("ModifyPermissionsBtn"):Enable(true)
		if not tCurr.nId then
			self.wndModify:FindChild("ModifyPermissionsBtn"):Enable(false)
		elseif tCurr.ePermissionNeighbor == HousingLib.NeighborPermissionLevel.Roommate then
			self.wndModify:FindChild("ModifyPermissionsBtn"):SetText(Apollo.GetString("Neighbors_SetToNormal"))
		else
			self.wndModify:FindChild("ModifyPermissionsBtn"):SetText(Apollo.GetString("Neighbors_SetToRoommate"))
		end
		self.wndModify:Show(true)
	end
end

function NNMainForm:OnModifyRemoveBtn(wndHandler, wndControl)
	NeighborNotes:RemoveSelectedPlayer()
	wndControl:GetParent():Show(false)
end

function NNMainForm:OnRemoveNN( wndHandler, wndControl)
	NeighborNotes:RemoveSelectedPlayerNote()
	wndControl:GetParent():Show(false)
end

function NNMainForm:OnModifyPermissionsBtn(wndHandler, wndControl)
	local tCurr = NeighborNotes.tLiveData.tSelectedNeighbor	
	if tCurr ~= nil and tCurr.nId then
		if tCurr.ePermissionNeighbor == HousingLib.NeighborPermissionLevel.Roommate then
			HousingLib.NeighborSetPermission(tCurr.nId, HousingLib.NeighborPermissionLevel.Normal)
		else
			HousingLib.NeighborSetPermission(tCurr.nId, HousingLib.NeighborPermissionLevel.Roommate)
		end
	end
	wndControl:GetParent():Show(false)
end

function NNMainForm:OnPlugListSelection( wndHandler, wndControl, eMouseButton )
	if wndControl:IsChecked() == false then
		wndControl:SetCheck(true)
	end
	if self.wndSelected then 
		self.wndSelected:SetCheck(false)
	end
	if wndControl:GetData() == 0 then
		NeighborNotes.tLiveData.tFilters.nPlug = nil
	else
		NeighborNotes.tLiveData.tFilters.nPlug = wndControl:GetData()
	end
	NeighborNotes:RefreshList()
	self.wndSelected = wndControl
	wndControl:GetParent():GetParent():GetParent():Show(false)
end

function NNMainForm:OnSearch( wndHandler, wndControl, eMouseButton )
	local wndCBSearch = self.wndMain:FindChild("CheckboxShowSearch")
	local wndCBNeighbors = self.wndMain:FindChild("CheckboxShowNeighbors")
	if wndControl:IsChecked() then
		wndCBSearch:SetCheck(true)
		wndCBNeighbors:SetCheck(false)
		self:OnAccountWideCheckBox( nil, wndCBSearch, nil )
	else
		wndCBSearch:SetCheck(false)
		wndCBNeighbors:SetCheck(true)
		self:OnAccountWideCheckBox( nil, wndCBNeighbors, nil )
	end
end

