-- Harvest Node Info
NeighborNotes.eGuildType = {
	["Guild"] = 1,
	["Circle"] = 2,
	["WarParty"] = 3,
	["ArenaTeam_2v2"] = 4,
	["ArenaTeam_3v3"] = 5,
	["ArenaTeam_5v5"] = 6,
}

NeighborNotes.tEnums = {
	tPlugType = {
		["Biome"]		= {	nID = 001,	strIcon = "CRB_MinimapSprites:sprMM_InstancePortal" },
		["Challenge"]	= { nID = 002,	strIcon = "IconSprites:Icon_Achievement_Achievement_Challenges" },
		["Expedition"]	= { nID = 003,	strIcon = "IconSprites:Icon_Achievement_Achievement_Shiphand" },
		["Dungeon"]		= { nID = 004,	strIcon = "IconSprites:Icon_Achievement_Achievement_Dungeon" },
		["Raid"]		= { nID = 005,	strIcon = "IconSprites:Icon_Achievement_Achievement_Raid" },
		["PublicEvent"] = { nID = 006,	strIcon = "IconSprites:Icon_Achievement_Achievement_WorldEvent" },
		["Item"]		= {	nID = 010,	strIcon = "" },
	},
	
	tSortType = {
		["Name"] = 1,
		["Node"] = 2,
		["Plug"] = 3,
		["Note"] = 4,
		["LastOnline"] = 5,
		["Permissions"] = 6,
	},

	tPlugs = {
		-- Useful Plots
		[001] = { strName = "Festival", strIcon = "IconSprites:Icon_Windows_UI_CRB_Adventure_Malgrave_Food" },
		[002] = { strName = "Eldan Statue", strIcon = "IconSprites:Icon_Map_Illium_DominionFloatingStatue" },
		[003] = { strName = "Vending Machine", strIcon = "IconSprites:Icon_MapNode_Map_vendor_Consumable" },
		[004] = { strName = "Crafting Kiosk", strIcon = "IconSprites:Icon_MapNode_Map_Tradeskill" },
		[005] = { strName = "Warhorn", strIcon = "IconSprites:Icon_ItemMisc_Horn_02" },
		[006] = { strName = "Mailbox", strIcon = "IconSprites:Icon_MapNode_Map_Mailbox" },
		[007] = { strName = "Storage Unit", strIcon = "IconSprites:Icon_MapNode_Map_Bank" },
		[008] = { strName = "Floor Piano", strIcon = "IconSprites:Icon_Housing1x1_1947_Darkspur_Floor_Piano_03" },
		[009] = { strName = "Customization Station", strIcon = "BK3:sprHolo_Icon_Costume" },
		
		[011] = { strName = "Festival Tier 1", strIcon = "IconSprites:Icon_Windows_UI_CRB_Adventure_Malgrave_Food" },
		[012] = { strName = "Festival Tier 2", strIcon = "IconSprites:Icon_Windows_UI_CRB_Adventure_Malgrave_Food" },
		[013] = { strName = "Festival Tier 3", strIcon = "IconSprites:Icon_Windows_UI_CRB_Adventure_Malgrave_Food" },
		[014] = { strName = "Festival Tier 4", strIcon = "IconSprites:Icon_Windows_UI_CRB_Adventure_Malgrave_Food" },
		[015] = { strName = "Festival Tier 5", strIcon = "IconSprites:Icon_Windows_UI_CRB_Adventure_Malgrave_Food" },
		[016] = { strName = "Festival Tier 6", strIcon = "IconSprites:Icon_Windows_UI_CRB_Adventure_Malgrave_Food" },
		
		-- Harvest Nodes
		[051]	= { strName = "Relic Excavation Tier 1" },
		[052]	= { strName = "Relic Excavation Tier 2" },
		[053]	= { strName = "Relic Excavation Tier 3" },
		[054]	= { strName = "Relic Excavation Tier 4" },
		[059]	= { strName = "Elite Relic Excavation" },
		[061]	= { strName = "Thicket Tier 1" },
		[062]	= { strName = "Thicket Tier 2", },
		[063]	= { strName = "Thicket Tier 3", },
		[064]	= { strName = "Thicket Tier 4", },
		[069]	= { strName = "Elite Thicket", },
		[071]	= { strName = "Mineral Deposit Tier 1" },
		[072]	= { strName = "Mineral Deposit Tier 2" },
		[073]	= { strName = "Mineral Deposit Tier 3" },
		[074]	= { strName = "Mineral Deposit Tier 4" },
		[079]	= { strName = "Elite Mineral Deposit" },
				
		-- Biome Teleports
		[101] = { strName = "Biome: Algoroc" },
		[102] = { strName = "Biome: Auroria" },
		[103] = { strName = "Biome: Celestion" },
		[104] = { strName = "Biome: Crimson Isle" },
		[105] = { strName = "Biome: Deradune" },
		[106] = { strName = "Biome: Ellevar" },
		[107] = { strName = "Biome: Everstar Grove" },
		[108] = { strName = "Biome: Farside" },
		[109] = { strName = "Biome: Galeras" },
		[110] = { strName = "Biome: Grimvault" },
		[111] = { strName = "Biome: Levian Bay" },
		[112] = { strName = "Biome: Malgrave" },
		[113] = { strName = "Biome: Northern Wilds" },
		[114] = { strName = "Biome: Whitevale" },
		[115] = { strName = "Biome: Wilderrun" },
		
		-- 1x1 Challenges
		[201] = { strName = "Anti-Air Defense Tower" },
		[202] = { strName = "Bone Pit" },
		[203] = { strName = "Cubig Feeder" },
		[204] = { strName = "Flying Saucer" },
		[205] = { strName = "Medical Station" },
		[206] = { strName = "Weather Control Station" },
		[207] = { strName = "Whirlwind" },
		
		-- 1x2 Challenges
		[301] = { strName = "Eldan Excavation" },
		[302] = { strName = "Garbage Dump" },
		[303] = { strName = "Ice Pond" },
		[304] = { strName = "Large Spiderland" },
		[305] = { strName = "Lopp Party" },
		[306] = { strName = "Magma Flow" },
		[307] = { strName = "Moonshiner Cabin" },
		[308] = { strName = "Prospector Plot" },  ---  NOT FOUND YET
		[309] = { strName = "Protostar Hazard Training Course" },
		[310] = { strName = "Shardspire Canyon" },
		[311] = { strName = "Spooky Graveyard" },
		[312] = { strName = "Osun Forge" },
		
		-- 1x1 Expeditions
		[401] = { strName = "EXPEDITION: Abandoned Eldan Test Lab" }, -- Conflicts with the other Instance Portals
		[402] = { strName = "EXPEDITION: Creepy Cave" }, -- Conflicts with the other Instance Portals
		[403] = { strName = "EXPEDITION: Kel Voreth Underforge" }, -- Conflicts with the other Instance Portals
		[404] = { strName = "EXPEDITION: Mayday" },
		
		-- 1x2 Expeditions
		--[501] = { strName = "",
		
		-- 1x1 Raids
		[601] = { strName = "Datascape Raid Portal" },
		
		-- 1x2 Raids
		--[701] = "",
		
		-- 1x1 Public Event
		--[801] = "",
		
		-- 1x2 Public Event
		[901] = { strName = "Blasted Landscape" },
		[902] = { strName = "Corrupted Laboratory" },
	},
}
	